class InitParserBreakpoint(gdb.Breakpoint):
	def stop(self):
		frame = gdb.selected_frame()
		block = frame.block()
		top_level_parse.init_parser()

		# This will also catch locals that aren't parsers, but it's not a problem in practice,
		# since h_parse() will never be called on them
		# If it becomes a problem after all, gdb.parse_and_eval() might be used to filter them out
		for p in block:
			top_level_parse.parser_objs[int(p.value(frame))] = Parser(p.name, int(p.value(frame)))

		return False

class PDFMainBreakpoint(gdb.Breakpoint):
	def stop(self):
		breakpoints = breakpoint_manager.set_hammer_retq_breakpoints()
		#breakpoint_manager.hammer_retq_breakpoints = breakpoints

		return True

	def set_hammer_retq_breakpoints(self):
		breakpoints = []
		plp_retq = locate_perform_lowlevel_parse_retq()
		perform_lowlevel_parse_ret = PerformLowLevelParseRetBreakpoint("*" + hex(plp_retq))
		breakpoints.append(perform_lowlevel_parse_ret)
		hpp_retq = locate_h_packrat_parse_retq()
		h_packrat_parse_ret = HPackratParseRetBreakpoint("*" + hex(hpp_retq))
		breakpoints.append(h_packrat_parse_ret)
		return breakpoints
