import unittest

class ParserStackPushPop(unittest.TestCase):
	def setUp(self):
		self.parser1 = Parser("foo", 1234)
		self.parser2 = Parser("bar", 1242)
		self.parser_stack = ParserStack(16, 32) # Made-up addresses

	def test_push(self):
		self.parser_stack.push(self.parser1)
		self.assertEqual(self.parser_stack.p_stack, [self.parser1])

	def test_pop(self):
		self.parser_stack.push(self.parser1)
		self.parser_stack.push(self.parser2)
		self.parser_stack.pop()
		self.assertEqual(self.parser_stack.p_stack, [self.parser1])

class ParserStackNaming(unittest.TestCase):
	def setUp(self):
		self.parser1 = Parser("foo", 1234)
		self.parser2 = Parser("bar", 1242)
		self.parser_stack = ParserStack(16, 32)
		self.parser_stack.push(self.parser1)
		self.parser_stack.push(self.parser2)

	def test_name_top_parser(self):
		parser3 = Parser(None, 1250)
		self.parser_stack.push(parser3)
		self.parser_stack.name_top_parser("foo2")
		parser3 = self.parser_stack.peek()
		self.assertEqual(parser3.name, "foo2")

	# TODO: should parsers be allowed to name only once?
	# TODO: parser unit test
	@unittest.expectedFailure
	def test_name_top_parser_twice(self):
		self.parser_stack.name_top_parser("something else")
		self.assertEqual(self.parser2.name, "something else")

